{$APPTYPE CONSOLE}
//psg files comparer (c)2001-2018 Sergey Bulba
//svbulba@gmail.com
//bulba.untergrund.net
program psgc;

uses sysutils;
var
 f1,f2:file;
 inter,i,skp1,skp2:integer;
 b,v:byte;
 regs1,regs2:array[0..13+1] of byte; //+1 for EnvT write flag
 buff1,buff2:packed array[0..32767] of byte;
 pos1,pos2,max1,max2:integer;
 eof1,eof2:boolean;

 function GetByte(n:integer):byte;
 begin
  case n of
  1:begin
     if pos1 >= max1 then
      begin
       BlockRead(f1,buff1,32768,max1);
       eof1 := eof(f1);
       pos1 := 0
      end;
     Result := buff1[pos1];
     inc(pos1)
    end;
  else
   begin
     if pos2 >= max2 then
      begin
       BlockRead(f2,buff2,32768,max2);
       eof2 := eof(f2);
       pos2 := 0
      end;
     Result := buff2[pos2];
     inc(pos2)
    end;
  end;
 end;

 function ef(n:integer):boolean;
 begin
  case n of
  1:Result := eof1 and (pos1 >= max1)
  else
    Result := eof2 and (pos2 >= max2)
  end
 end;

 function DifMixer:boolean; inline;
 begin
  if ((((regs1[7] and 9) = 9) or (regs1[8] = 0)) and //no sound A
      (((regs2[7] and 9) = 9) or (regs2[8] = 0))) or
     ((((regs1[7] and 18) = 18) or (regs1[9] = 0)) and //no sound B
      (((regs2[7] and 18) = 18) or (regs2[9] = 0))) or
     ((((regs1[7] and 36) = 36) or (regs1[10] = 0)) and //no sound C
      (((regs2[7] and 36) = 36) or (regs2[10] = 0))) then
   exit(False);
  Result := regs1[7] <> regs2[7];
 end;

 function DifTonA:boolean; inline;
 begin
  Result := not(
     ((regs1[8] = 0) and (regs2[8] = 0)) or //no sound (AmplA=0)
     (regs1[7] and 1 <> 0) or //no tone (MixerA=0)
     ((regs1[0] = regs2[0]) and (regs1[1] = regs2[1])) or //same TonA
     ((regs1[1] = 0) and (regs2[1] = 0) and //TonA 000=001 or 001=000
      (((regs1[0] = 0) and (regs2[0] = 1)) or
       ((regs1[0] = 1) and (regs2[0] = 0))))
     );
 end;

 function DifTonB:boolean; inline;
 begin
  Result := not(
     ((regs1[9] = 0) and (regs2[9] = 0)) or //no sound (AmplB=0)
     (regs1[7] and 2 <> 0) or //no tone (MixerB=0)
     ((regs1[2] = regs2[2]) and (regs1[3] = regs2[3])) or //same TonB
     ((regs1[3] = 0) and (regs2[3] = 0) and //TonB 000=001 or 001=000
      (((regs1[2] = 0) and (regs2[2] = 1)) or
       ((regs1[2] = 1) and (regs2[2] = 0))))
     );
 end;

 function DifTonC:boolean; inline;
 begin
  Result := not(
     ((regs1[10] = 0) and (regs2[10] = 0)) or //no sound (AmplC=0)
     (regs1[7] and 4 <> 0) or //no tone (MixerC=0)
     ((regs1[4] = regs2[4]) and (regs1[5] = regs2[5])) or //same TonC
     ((regs1[5] = 0) and (regs2[5] = 0) and //TonC 000=001 or 001=000
      (((regs1[4] = 0) and (regs2[4] = 1)) or
       ((regs1[4] = 1) and (regs2[4] = 0))))
     );
 end;

 function DifNs:boolean; inline;
 begin
  if regs1[7] and 56 = 56 then //no noise (MixerABC=111)
   exit(False);
  if ((regs1[7] and 8 = 0) and
      ((regs1[8] <> 0) or (regs2[8] <> 0))) or //MixerA noise and AmplA
     ((regs1[7] and 16 = 0) and
      ((regs1[9] <> 0) or (regs2[9] <> 0))) or //MixerB noise and AmplB
     ((regs1[7] and 32 = 0) and
      ((regs1[10] <> 0) or (regs2[10] <> 0))) then //MixerC noise and AmplC
   exit((regs1[6] <> regs2[6]) and //Noise
         (((regs1[6] <> 0) and (regs2[6] <> 1)) or //Ns 0=1
          ((regs1[6] <> 1) and (regs2[6] <> 0)))); //Ns 1=0
  Result := False;
 end;

 function DifEnvA:boolean; inline;
 begin
  Result := not(
   (regs1[8] and 16) = (regs2[8] and 16)); //both envelope or both no envelope
 end;

 function DifEnvB:boolean; inline;
 begin
  Result := not(
   (regs1[9] and 16) = (regs2[9] and 16)); //both envelope or both no envelope
 end;

 function DifEnvC:boolean; inline;
 begin
  Result := not(
   (regs1[10] and 16) = (regs2[10] and 16)); //both envelope or both no envelope
 end;

 function DifEnv:boolean; inline;
 begin
  if ((regs1[8] and 16 <> 0) or //EnvA
      (regs1[9] and 16 <> 0) or //EnvB
      (regs1[10] and 16 <> 0) or //EnvC
      (regs2[8] and 16 <> 0) or //EnvA
      (regs2[9] and 16 <> 0) or //EnvB
      (regs2[10] and 16 <> 0)) then //EnvC
   exit((regs1[14] <> regs2[14]) or //EnvT written
        (regs1[13] <> regs2[13]) or //EnvT value
        (regs1[12] <> regs2[12]) or //EnvP high
        ((regs1[11] <> regs2[11]) and //EnvP low
         ((regs1[12] <> 0) or //EnvP <> $00xx
          ((regs1[11] <> 0) and (regs2[11] <> 1)) or //Env 0=1
          ((regs1[11] <> 1) and (regs2[11] <> 0))))); //Env 0=1
  Result := False;
 end;

 function DifAmpA:boolean; inline;
 begin
  if (regs1[8] and 16 = 0) and (regs2[8] and 16 = 0) then //no EnvA
   exit((regs1[8] and 15) <> (regs2[8] and 15)); //AmplA
  Result := False;
 end;

 function DifAmpB:boolean; inline;
 begin
  if (regs1[9] and 16 = 0) and (regs2[9] and 16 = 0) then //no EnvB
   exit((regs1[9] and 15) <> (regs2[9] and 15)); //AmplB
  Result := False;
 end;

 function DifAmpC:boolean; inline;
 begin
  if (regs1[10] and 16 = 0) and (regs2[10] and 16 = 0) then //no EnvC
   exit((regs1[10] and 15) <> (regs2[10] and 15)); //AmplC
  Result := False;
 end;

begin
if ParamCount <> 2 then
 begin
  Writeln('PSG files smart comparer (c)2001-2018 Sergey Bulba');
  Writeln('svbulba@gmail.com');
  Writeln('bulba.untergrund.net');
  Writeln;
  Writeln('Smart mean that not simple byte to byte compare, both PSG can sound same, even' +
   ' if different values are written into sound chip registers');
  Writeln;
  Writeln('Give me two psg files to compare');
  Halt(1);
 end;
if not FileExists(Paramstr(1)) or not FileExists(Paramstr(2)) then
 begin
  Writeln('File(s) not found');
  Halt(1);
 end;
Assign(f1,Paramstr(1));
Assign(f2,Paramstr(2));
FileMode := 0;
Reset(f1,1);Reset(f2,1);
try
Seek(f1,16);Seek(f2,16);
pos1 := 0; pos2 := 0; max1 := 0; max2 := 0;
eof1 := False; eof2 := False;
inter := 0;
for i := 0 to 13 do regs1[i] := 0;
for i := 0 to 13 do regs2[i] := 0;
skp1 := 0;
skp2 := 0;
while not ef(1) and not ef(2) do
 begin
  regs1[14] := 0; //no EnvT write
  regs2[14] := 0; //no EnvT write
  if skp1 = 0 then
  begin
  repeat
  b := GetByte(1);
  if (b <> $ff) and (not ef(1)) then
   begin
    v := GetByte(1);
    if b < 14 then
     case b of
     1,3,5:regs1[b] := v and 15;
     6,8,9,10:regs1[b] := v and 31;
     7:regs1[b] := v and 63;
     13:
       begin
        regs1[13] := v and 15;
        regs1[14] := 1; //EnvT write flag
       end;
     else regs1[b] := v;
     end
    else if b = $fe then
     begin
      skp1 := v*4 - 1;
      break
     end
   end
  until (b in [$fe,$ff]) or ef(1);
  end
  else dec(skp1);
  if skp2 = 0 then
  begin
  repeat
  b := GetByte(2);
  if (b <> $ff) and (not ef(2)) then
   begin
    v := GetByte(2);
    if b < 14 then
     case b of
     1,3,5:regs2[b] := v and 15;
     6,8,9,10:regs2[b] := v and 31;
     7:regs2[b] := v and 63;
     13:
       begin
        regs2[13] := v and 15;
        regs2[14] := 1; //EnvT write flag
       end;
     else regs2[b] := v;
     end
    else if b = $fe then
     begin
      skp2 := v*4 - 1;
      break
     end
   end
  until (b in [$fe,$ff]) or ef(2);
  end
  else dec(skp2);
{  for i := 0 to 13 do
   if regs1[i] <> regs2[i] then} //smart compare instead

 {
   if (regs1[7] <> regs2[7]) or
      ((regs1[8] and regs2[8] and 16 = 0) and
       (regs1[8] <> regs2[8])) or
      ((regs1[9] and regs2[9] and 16 = 0) and
       (regs1[9] <> regs2[9])) or
      ((regs1[10] and regs2[10] and 16 = 0) and
       (regs1[10] <> regs2[10])) or
      (((regs1[7] and 1) = 0) and (regs2[8] <> 0) and
       ((regs1[0] <> regs2[0]) or (regs1[1] <> regs2[1]))) or
      (((regs1[7] and 2) = 0) and (regs2[9] <> 0) and
       ((regs1[2] <> regs2[2]) or (regs1[3] <> regs2[3]))) or
      (((regs1[7] and 4) = 0) and (regs2[10] <> 0) and
       ((regs1[4] <> regs2[4]) or (regs1[5] <> regs2[5]))) or
      (((regs1[7] and 8) = 0) and (regs2[8] <> 0) and
       (regs1[6] <> regs2[6])) or
      (((regs1[7] and 16) = 0) and (regs2[9] <> 0) and
       (regs1[6] <> regs2[6])) or
      (((regs1[7] and 32) = 0) and (regs2[10] <> 0) and
       (regs1[6] <> regs2[6])) or
      ((((regs1[8] and 16) <> 0) or
        ((regs1[9] and 16) <> 0) or
        ((regs1[10] and 16) <> 0)) and
       ((regs1[11] <> regs2[11]) or
        (regs1[12] <> regs2[12]) or
        (regs1[13] <> regs2[13]))) then} //more smart instead

  if DifMixer or
     DifTonA or
     DifTonB or
     DifTonC or
     DifNs or
     DifEnvA or
     DifEnvB or
     DifEnvC or
     DifEnv or
     DifAmpA or
     DifAmpB or
     DifAmpC then

    begin
     Writeln('Difference in ',inter,' interrupt.');
     Writeln('TonA TonB TonC Ns Mx AA AB AC EnvP ET ETWrite');
     Write(IntToHex(regs1[0] + regs1[1] shl 8,4),' ');
     Write(IntToHex(regs1[2] + regs1[3] shl 8,4),' ');
     Write(IntToHex(regs1[4] + regs1[5] shl 8,4),' ');
     Write(IntToHex(regs1[6],2),' ');
     Write(IntToHex(regs1[7],2),' ');
     Write(IntToHex(regs1[8],2),' ');
     Write(IntToHex(regs1[9],2),' ');
     Write(IntToHex(regs1[10],2),' ');
     Write(IntToHex(regs1[11] + regs1[12] shl 8,4),' ');
     Write(IntToHex(regs1[13],2),' ');
     if regs1[14] <> 0 then
      Write('Yes')
     else
      Write('No');
     Writeln;
     Write(IntToHex(regs2[0] + regs2[1] shl 8,4),' ');
     Write(IntToHex(regs2[2] + regs2[3] shl 8,4),' ');
     Write(IntToHex(regs2[4] + regs2[5] shl 8,4),' ');
     Write(IntToHex(regs2[6],2),' ');
     Write(IntToHex(regs2[7],2),' ');
     Write(IntToHex(regs2[8],2),' ');
     Write(IntToHex(regs2[9],2),' ');
     Write(IntToHex(regs2[10],2),' ');
     Write(IntToHex(regs2[11] + regs2[12] shl 8,4),' ');
     Write(IntToHex(regs2[13],2),' ');
     if regs2[14] <> 0 then
      Write('Yes')
     else
      Write('No');
     Writeln;
     Halt(1);
   end;
  inc(inter)
 end;
Write('Both PSG-files sound identically');
if not ef(1) then
 Write(', but second file shorter')
else if not ef(2) then
 Write(', but first file shorter');
Writeln 
finally
CloseFile(f1);CloseFile(f2)
end
end.
